#include <iostream>

using namespace std;

string s;
int pos = 0;

long long parseExpression (bool parseRightSide) {
    long long leftSideResult = 0;

    if (s[pos] == '1') {
        pos++;
        return 1;
    } else if (s[pos] == '(') {
        pos++;
        leftSideResult = parseExpression(true);
        pos++; // za )
    }

    long long result = leftSideResult;

    if (parseRightSide) {
        while (s[pos] == '*') {
            pos++;
            long long rightSideResult = parseExpression(false);

            result *= rightSideResult;
        }
        if (s[pos] == '+' && s[pos + 1] == '1') {
            pos += 2;

            result += 1;
        }
    }

    return result;
}

int main() {
    ios_base::sync_with_stdio (0);
    std::cin.tie (0);

    int N;
    cin >> N;


    cin >> s;
    int result = 0;

    for (int i = s.length() - 2; i >= 0; i--) {
        char nextParen = s[i + 1];
        char currParen = s[i];

        if (currParen == ')' && nextParen == '(') {
            s.insert(i + 1, "*");
        } else if (currParen == '(' && nextParen == ')') {
            s.insert(i + 1, "1");
        } else if (currParen == ')' && nextParen == ')') {
            s.insert(i + 1, "+1");
        }
    }

    std::cout << parseExpression (true) << std::endl;
    return 0;
}
